def addtoreagentlist(reagents,rxn):
    for j in range (0, len(rxn)):
        isinreagentlist = false
        for i in range (0, len(reagents)):
            #check species against list
            if (rxn[j][1]==reagents[i]):
                isinreagentlist=true
        if (isinreagentlist==false):
            reagents.append(rxn[j][1])

#Definition of reaction mechanism tuple:
#	tuple of reaction tuples + a rate constant for each
#	reaction_mechanism=[[rxn,rate],[]..]

def appendrxntomech(mech,rxn,rate): #add a reaction and its rate to a mechanism tuple
	mech.append([rxn,rate])

def ratelawfrommech(reagent, mech):
	whichreactant = [] #this is a tuple used to keep track of where the species appears
			   #in each reaction.
	total = 0
	ordererror=False
	# will take mechanism and generate the rate law for a particular species.
	# cycle through the rxns
	#indices in a mech       []        []          []            []
	#                      [rxn,k]   rxn or k     reactant      reactant attributes
        # possible values      0..n       0 or 1      0...n         0 .. 5
	for i in range (0, len(mech)):
		#if reagent appears in the rxn it contributes to rate of change
		contribution = var(mech[i][1])  #start with rate constant
		order = 0
		t=var('t')
		reactantfactor = 0 #This is the factor we use to take care of stoich of reactant
		productfactor = 0 # same for product.
		for j in range (0, len(mech[i][0])):
			if (mech[i][0][j][2] == 'reactant'):
				tempspecies = mech[i][0][j][1]
				tempspeciesfunc=function(tempspecies,t)
				contribution = contribution*tempspeciesfunc^mech[i][0][j][0]
				order = order + mech[i][0][j][0]
#note if A + A + B -k-> C + A (not likely because trimolecular) dA/dt = -2k[A][A][B]  + k[A][A][B]
				if (mech[i][0][j][1] == reagent): #querying the species
					reactantfactor = reactantfactor + mech[i][0][j][0]
			if ((mech[i][0][j][2]=='product') and (mech[i][0][j][1] == reagent)):
				productfactor = productfactor + mech[i][0][j][0]
                        if (order > 2) and ((reactantfactor!=0)or(productfactor!=0)): 
			    ordererror = True
		total = -1*reactantfactor*contribution + productfactor*contribution + total
	if (ordererror):
		warnstr = "Warning for reactions involving " + reagent + ":"
                print warnstr
		print "Your mechanism has termolecular or higher order steps.  This is probably an error."
	#Now need to return the rate law.
	return(total)

def rxnmechtodiffratelaws(mech):
	reagents = []
	rate = []
	ratelaw = []
	var('t')
	for k in range (0,len(mech)):
		addtoreagentlist(reagents, mech[k][0])
	for k in range (0, len(reagents)):
		tempfunc =function(reagents[k],t)
		rate.append(diff(tempfunc,t))
		ratelaw.append(ratelawfrommech(reagents[k],mech))
	return([rate,ratelaw])

def derivative_expression2str(deriv,var):
    # deriv is the derivative expression e.g. diff(C,t)
    # var is what the derivative was taken with respect to, e.g t in above expression.
    tempfunc = integral(deriv,var)
    return('d'+str(tempfunc)+'/d'+str(var))

def prettymech(mech):
    for i in range (0, len(mech)):
        prettyrxn(mech[i][0],str(mech[i][1]))

def prettydiffratelaws(difflaws):
	print ('Differential rate laws for mechanism:')
	for i in range (0, len(difflaws[0])):
		ratelawstr='$'+latex(difflaws[0][i])+' = ' + latex(difflaws[1][i])+'$'
		html(ratelawstr)
		