#These routines perform propagation of symmetric (guassian) errors
#J. Gutow October 21, 2011

def sq_elem(vec):
    for i in range (0, len(vec)):
        vec[i] = vec[i]*vec[i]
    return vec
    
def sym_gauss_err(f,uvar,*kwds):
    if (kwds):
        key = kwds[0]
    else:
        key = "quiet"
    evec = []
    gradstr = "("
    gradient = f.gradient(uvar)
    if (key =="verbose"):
        for i in range (0,len(uvar)):
            gradstr = gradstr+"d/d"+str(uvar[i])+", "
        gradstr = gradstr[0:-2] + ")"
        print "Step 1: find the gradient (derivatives w.r.t. each uncertain variable)"
        print "of the function. These are listed below as "+gradstr+":"
        pretty_print(gradient)
    for i in range (0, len(uvar)):
        name = "e_"+str(uvar[i])
        tempvar = var(name)
        evec.append(tempvar)
    evecsq = simplify(vector(sq_elem(evec)))
    gradsq = simplify(vector(sq_elem(gradient)))
    err = sqrt(simplify(abs(gradsq*(evecsq.column()))))
    if (key =="verbose"):
        print "Step 2: multiply the square of each derivative by the square of the error"
        print "in the variable the derivative was w.r.t.  Sum these products and take the"
        print "square root.  This is the error."
        pretty_print(err)
    return err

def check_sym_err(f, uvar, err):
    #f = the symbolic expression through which error is propogated.
    #uvar = list of tuples containing [variable, value, uncertainty].
    #err is the numerical value to compare with the calculated error.
    have_err = [] 
    uncert = []
    uncert_sym = []
    callstr = "sym_err("
    for i in range (0, len(uvar)):
        callstr +=str(uvar[i][0])+"="+str(uvar[i][1])
        if (uvar[i][2]!=0):
            callstr +=","
            have_err.append(uvar[i][0])
            uncert.append(uvar[i][2])
            uncert_sym.append("e_"+str(uvar[i][0]))
            callstr +="e_"+str(uvar[i][0])+"="+str(uvar[i][2])
        if (i+1 < len(uvar)):
            callstr +=","
    callstr+=")"
#    print callstr
    print "parameters you have said have errors:" +str(have_err)
#    print uncert_sym
#    print uncert
    sym_err=sym_gauss_err(f,have_err,"quiet") 
    num_err = eval(callstr)
    error_check = (abs(err-num_err))/num_err
    if (error_check > 0.1):
        print "Your error is off of the correct value by > 10%.  Check your equations."
        power10 = round(log((err/num_err),10))
        print "Your error is off by approximately "+str(power10)+" orders of magnitude."
    else:
        print "Your error is within 10% of the correct value.  Good."