def p_chem_constants():
    SI_units()  #requires
    var('c e F k R h hbar N_A u m_e m_p m_n a_o G')
    global c, e, F, k, R, h, hbar, N_A, u, m_e, m_p, m_n, a_o, G
    c = 2.99792558e8*m*s^-1
    e = 1.602176e-19*C
    N_A = 6.02214e23*mol^-1
    F = e*N_A
    k = 1.38065e-23*J*K^-1
    R=N_A*k
    h = 6.62608e-34*J*s
    hbar=h/2/(pi.n(20))
    u=1.66054e-27*kg
    m_e=9.10938e-31*kg
    m_p=1.67262e-27*kg
    m_n=1.67493e-27*kg
    a_o = 5.29177e-11*m
    G = 6.673e-11*N*m^2/kg^2
    print "Have assigned the following physical constant values to the following"
    print "symbols:"
    print "speed of light c ="+str(c)
    print "elementary charge e="+str(e)
    print "Avogadro's number N_A="+str(N_A)
    print "Faraday's constant F = "+str(F)
    print "Boltzmann constants k = "+str(k)
    print "Gas constant R = "+str(R)
    print "Planck's constant h = "+str(h)
    print "Planck's constant/2/pi hbar = "+str(hbar)
    print "atomic mass unit u = "+str(u)
    print "mass of electron m_e = "+str(m_e)
    print "mass of proton m_p = "+str(m_p)
    print "mass of neutron m_n = "+str(m_n)
    print "Bohr radius a_o = "+str(a_o)
    print "gravitational constant G = "+str(G)
    print "Note that some of these have too many significant figures.  You can"
    print "also assign your preferred values to any of the variables simply by"
    print "typing 'variablename = newvalue' on the command line."
    print "A specific example might be a more approximate speed of light by"
    print "typing 'c = 3.00e8*m/s'."