#These routines are the ones that generate interactive questions to use in worksheets

#Generic Routines
def strings_to_function(functionname, argstr, linesofcode, debug = False):
#functionname = the name of the function, filename = functionname.sage
#argstr = string representation of arguments passed ie file will contain the following string:
#'def '+functionname+'('+argstr+'):' as the first line of the function definition.
#linesofcode = tuple of strings.  Each string is one line of code, including necessary tabs.
#debug = True causes the function to be written to a file for visual inspection.
    functionstr = ''
    functionstr = 'def '+functionname+'('+argstr+'):\n'
    for i in range(0,len(linesofcode)):
        functionstr = functionstr + (linesofcode[i]+'\n')
    if debug:
        o=open(functionname+'.sage','w')
        o.write(functionstr)
        o.close()
    return(functionstr)

#Mechanisms to differential rate laws
def question_mech2diff_ratelaw(mechsteps, maxreagents, questname):
#FOR THIS TO WORK THE RETURNED DATA MUST BE PUT IN A VARIABLE NAMED questname+'_data'
#this function generates the input to interact function
#mechsteps is the number of steps the mechanism should have (1 or more) fewer steps easier.
#maxreagents is the maximum number of reagents to include in the mechanism
#questname will be used as a function name and the question label.  
#It should be unique within a worksheet and start with a letter.
# Example Usage:
#     p1_data = question_mech2diff_ratelaw(2,4,'p1')
#     exec(p1_data[0])
#     evaluate the cell
# IN THE NEXT CELL
#     interact(p1)
#generate the mechanism
    var('k')
    mech = randommech(mechsteps, maxreagents)
    prettymech(mech)
    html('Consider the mechanism above.')
    html( 'Type the differential rate law for each species in the boxes below.')
    html( 'If the boxes don\'t appear after the next cell click \"evaluate\" below the cell.')
    html( 'When done you can check your answers by clicking on the \"Check\" box.')
    print 'INPUT FORMAT INFORMATION:'
    print 'The time dependent amount of a species is represented by the species symbol followed'
    print 'by \"t\" in parenthesis, as in A(t).  The square of this is written as A(t)^2 and'
    print 'you must use the * to represent multiplication. Subscripts are preceded by an _ as'
    print 'in k_1, for the first rate constant.'
    #find the answer(s)
    difflaws = rxnmechtodiffratelaws(mech)
    #define the function that interact will call
    #this holds the arguments for the function that is being generated.
    argstr = ''
    for i in range (0, len(difflaws[0])):
        labelstr = 'd'+str(integral(difflaws[0][i],t)).replace('\n','').replace(' ','')+'/dt='
        argstr = argstr+'u'+str(i)+'=input_box(label=\''+labelstr+'\',default=k),'  #don't forget to define k as a variable
    argstr = argstr+'answercheck=checkbox(label = \'When done check this box to get your answers checked\',default = False)'
	#define the lines of code for the function called by interact
    linesofcode=[]
    linesofcode.append('\tif answercheck == True:')
    linesofcode.append('\t\tcorrect = True')
    #Need to hard code the function input arguments in. Can't seem to do it on the fly.
    for i in range (0,len(difflaws[0])):
        linesofcode.append('\t\ttempanswer = u'+str(i))
#        linesofcode.append('\t\tprint u'+str(i))
#        linesofcode.append('\t\tprint '+questname+'_data[1][1][1]['+str(i)+']')
        linesofcode.append('\t\tif tempanswer!='+questname+'_data[1][1][1]['+str(i)+']:')
        linesofcode.append('\t\t\tcorrect = False')
        linesofcode.append('\t\t\tprint \'Check rate law # '+str(i+1)+'\'')
    linesofcode.append('\t\tif correct:')
    linesofcode.append('\t\t\tprint \'All answers correct!\'')
    linesofcode.append('\t\telse:')
    linesofcode.append('\t\t\tprint \'Not all answer are correct. Try again.\'')
    functionstr = strings_to_function(questname,argstr,linesofcode)
#        print functionstr
    if functionstr == '':
	print 'Error creating function. Aborting.'
	exit
    functiondata = [mech, difflaws]
    return([functionstr,functiondata])