def rxnsplit(t):
    t = t.replace('-','')
    t = t.replace(' ','')
    t = t.replace('*','')
    list =t.split('>')
#    print list
#    print list
    reac = list[0].split('+')
    prod = list[1].split('+')
#    print reac
#    print prod
    return([reac,prod])

def stoich(t):
    import re
    item=re.compile('^[\d]+')
    stoichnum=item.search(t)
    if stoichnum!=None:
        return int(stoichnum.group())
    if stoichnum==None:
        return(1)

def phase_purity(r):
    import re
    item=re.compile('\([\s\w,]+\)$')
    phase_purity = item.search(r) 
    if phase_purity!=None:
        phase_purity = phase_purity.group()
        phase_purity=phase_purity[1:(len(phase_purity)-1)]
        phase_purity = phase_purity.split(',')
        if type(phase_purity) != tuple:  #if only have one element assume just the phase is provided
            if phase_purity[0]=='s': #then assume it is of constant composition.
                phase_purity.append('pure')
                return phase_purity
            if phase_purity[0]!='s': #then assume it is in solution and not the solvent
                phase_purity.append('solution')
                return phase_purity
    if phase_purity == None: #then assume it is in a solution and concentration varies
        return(['unknown','solution'])

def reagent(r):
    import re
    phase_purity = re.compile('\([\s\w,]+\)$')
    stoich=re.compile('^[\d]+')
    end=phase_purity.search(r)
    if end!=None:
	end = end.start()
    if end==None:
	end = len(r)
    start = stoich.search(r)
    if start!=None:
	start=start.end()
    if start==None:
	start=0
    return(r[start:end])

def str2rxn(s): #this routine uses rxnsplit(t), stoich(t), phase_purity(r), reagent(r) to turn a string into
		#a tuple representing a chemical reaction.  Although chemical formuli may be used they are
		#not handled very well, as the chemical formuli do not interpret well when making variables.
		#the requirements of the string are that '->' is used to represent the arrow.  Phase information
		# is included in parenthesis after each reagent in the form (phase,purity), where phase = l,g,s, aq
		#or p for liquid, gas, solid, aqueous or plasma and purity = pure, solution or solvent.  If the
		#purity is left out the following assumption is made:  the solid phase is pure all other phases
		#indicate a solution. 
    reaction = []
    parts = rxnsplit(s)
    for i in range(0,len(parts[0])):
	temp_stoich = stoich(parts[0][i])
	temp_phase_purity = phase_purity(parts[0][i])
	temp_reagent = reagent(parts[0][i])
	species = [temp_stoich, temp_reagent,'reactant',temp_phase_purity[0],temp_phase_purity[1]]
	reaction.append(species)
    for i in range(0,len(parts[1])):
	temp_stoich = stoich(parts[1][i])
	temp_phase_purity = phase_purity(parts[1][i])
	temp_reagent = reagent(parts[1][i])
	species = [temp_stoich, temp_reagent,'product',temp_phase_purity[0],temp_phase_purity[1]] 
	reaction.append(species)       
    return(reaction)

def reagent2str(reagent):
	stoich = str(reagent[0])
	if (reagent[0] ==1):
		stoich=''
	reagentstr = stoich+reagent[1]+'('+reagent[3]+','+reagent[4]+')'	
	return reagentstr

def prettyrxn(rxn,rateconst):  #This generates html output to be interpreted by jsMath to make pretty rxns.
				#rxn is the rxn structure defined above
				#rateconstant is a string representation of the rate constant, pass an empty string
				#    if there is not one.
    reactants = ''
    products = ''
    usedflag = False
    for i in range (0, len(rxn)):
        if (rxn[i][2] == 'reactant') and (reactants=='')and(usedflag==False):
            reactants = reagent2str(rxn[i])
            usedflag=True
        if (rxn[i][2] == 'reactant') and (reactants!='')and(usedflag==False):
            reactants = reactants + ' + '+ reagent2str(rxn[i])
            usedflag=True
        if (rxn[i][2] == 'product')and (products=='')and(usedflag==False):
            products = reagent2str(rxn[i])
            usedflag=True
        if (rxn[i][2] == 'product')and (products!='')and(usedflag==False):
            stoich = str(rxn[i][0])
            if (rxn[i][0]==1):
                stoich = ''
            products = products + ' + ' + reagent2str(rxn[i])
            usedflag=True
        usedflag=False #reset for next loop
    arrow = '\\rightarrow '
    if (rateconst!=''):
        arrow = '-\!-'+rateconst+'\\rightarrow '
    reactionstr = '$'+reactants +arrow+products+'$<br/>'
    #print reactionstr
    html (reactionstr)